/* dsge_gentraj.g
**
** The program computes trajectories from the 
** the VAR model.
*/

/********************************************************************
* Initialize input files 
********************************************************************/

lpara       = lpath $+ "/mhrun" $+ mhrun $+ "/pa.dat";
open fhpara = ^lpara for read;

/********************************************************************
* Generated draws from predictive density
********************************************************************/
eofloop = 0;
loopct  = 1;

do until eofloop; 

   /** Read blocks of size nblock **/
   parasim = readr (fhpara, nblock);
   nread   = rows (parasim);
   npara   = cols (parasim);

   /** use every nuse-th draw **/
   indseq  = seqa (1, 1, nread);
   indseq  = indseq % nuse;
   indseq  = indseq .ne 0;

   parasim = delif (parasim, indseq);
   nread   = rows (parasim);

   if ismiss (parasim) == 0;

      eofloop = eof (fhpara);   
      j = 1;

      do until j > nread;

    	 YYsim = dsgepred(parasim[j,.]',YY,Psize);

         opath  = specpath $+ "/traj" $+ ftos(loopct,"%*.*lf",1,0);
         chkdir = chk_dir(opath);
                  
         oYYsim = opath $+ "/YY.dat";
 	     create fhYYsim2 = ^oYYsim with YYsim, nv_, 8;
	     wr = writer(fhYYsim2, (YYR|YYsim) );
	     wr = close(fhYYsim2);
  
     	 j = j+1;
         loopct = loopct + 1;
      endo;

   endif;

endo;

closeall fhpara;


