/* dsge_pred.g
**
** The program computes trajectories from the 
** the DSGE model.
*/

vsel = {1 2 3};
/********************************************************************
* Initialize input files 
********************************************************************/
lpara       = lpath $+ "/pa.dat";
open fhpara = ^lpara for read;

parasim0 = readr(fhpara, 1);

eofloop = 0;

do until eofloop; 

   /** Read blocks of size nblock **/
   parasim = readr (fhpara, nblock);
   nread   = rows (parasim);
   npara   = cols (parasim);

   /** use every nuse-th draw **/
   indseq  = seqa (1, 1, nread);
   indseq  = indseq % nuse;
   indseq  = indseq .ne 0;

   parasim0 = parasim0 | delif (parasim, indseq);

   if ismiss (parasim) == 0;

      eofloop = eof (fhpara);   

   endif;

endo;
closeall fhpara;
p0 = meanc(parasim0);


{TT,QQ,RR,HH,DD,ZZ,VV,RC} = sysmat(p0, msel);
lab = "sigR" $|
      "sigG" $|
      "sigZ";


format /mat /on /mb1 /rds 7,4;

"total correlation:";
P0 = dlyap(TT, RR*QQ*RR');
GAM0 = ZZ*P0*ZZ';
iSTD0 = 1 ./ sqrt(diag(GAM0));
iSTD0 = diagrv(eye(rows(QQ)), iSTD0) ;
COR0 = iSTD0*GAM0*iSTD0;
COR0[vsel, vsel];

i = 1;
do until i > rows(QQ);
   QQi = zeros(rows(QQ), rows(QQ));
   QQi[i, i] = QQ[i, i];
   P0 = dlyap(TT, RR*QQi*RR');
   GAM0 = ZZ*P0*ZZ';
 
   "only shock: ";; $lab[i];; QQ[i, i];;
   
   GAM0[vsel, vsel];
   ""; 

   QQi = QQ;
   QQi[i, i] = 0.0;
   P0 = dlyap(TT, RR*QQi*RR');
   GAM0 = ZZ*P0*ZZ';
   iSTD0 = 1 ./ sqrt(diag(GAM0));
   iSTD0 = diagrv(eye(rows(QQ)), iSTD0) ;
   COR0 = iSTD0*GAM0*iSTD0;
   COR0[vsel, vsel];
   "-----------------------------------------";
   i = i + 1;
endo;
format /mat /on /mb1 /rds 16,8;
