/* dsge_predeval.g
**
** Takes draws from predictive density and constructs rmse forecast errors
** for unconditional and conditional forecasts.
*/ 

/*******************************************************************
* Read Forecast Densities
*******************************************************************/
corvar = 1~2~3;
corh = 1~4;

ind = {};
i = 1;
lab = {};
do until i > cols(corh);
  ind = ind ~ (corh[i] + hmaxact.*(corvar-1));
  lab = lab $| (titlestr[corvar] $+ "(+" $+ ftos(corh[i],"%*.*lf",1,0) $+ ")");
  i = i + 1;   
endo;

lpred       = lpath $+ "/predvar.dat";
open fhpred = ^lpred for read;

eofloop = 0;
loopct  = 1;
predsim_total = ones(1,nv_*hmaxact);

"Selected Correlations of the predictive density:";


do until eofloop; 

   /** Read blocks of size nblock **/
   predsim = readr(fhpred,nblock);
   predsim_total = predsim_total|predsim;
   loopct = loopct + 1;
	
   eofloop = eof(fhpred);
endo;

predsim_total = predsim_total[2:rows(predsim_total), ind];



closeall fhpred;
format /mat /on /mb1 /rds 7,2;
format /sa /on /mb1 /rds 7,7;
corpred = corrx(predsim_total);
$("      "$|lab)';;
"";
i = 1;
do until i > rows(corpred);
$lab[i];; corpred[i, .];
i = i + 1;
endo;
format /mat /on /mb1 /ro 16,8;

dsgecor[sampleind, .] = corpred[4, 5] ~ corpred[4, 6] ~ corpred[5, 6];
