/* dsge_gentraj.g
**
** The program computes trajectories from the 
** the VAR model.
*/

/********************************************************************
* Initialize input files 
********************************************************************/

lpara       = lpath $+ "/mhrun" $+ mhrun $+ "/pa.dat";
open fhpara = ^lpara for read;

/********************************************************************
* Generated draws from predictive density
********************************************************************/
eofloop = 0;
loopct  = 1;
Pextend = 35;
do until eofloop; 

   /** Read blocks of size nblock **/
   parasim = readr (fhpara, nblock);
   nread   = rows (parasim);
   npara   = cols (parasim);

   /** use every nuse-th draw **/
   indseq  = seqa (1, 1, nread);
   indseq  = indseq % nuse;
   indseq  = indseq .ne 0;

   parasim = delif (parasim, indseq);
   nread   = rows (parasim);

   if ismiss (parasim) == 0;

      eofloop = eof (fhpara);   
      j = 1;

      do until j > nread;

         // open old trajectoryn
         opath  = specpath $+ "/traj" $+ ftos(loopct,"%*.*lf",1,0);
         chkdir = chk_dir(opath);
         fhsim = opath $+ "/YY.dat";
         open fhsimdata = ^fhsim for read;

         // read in the 'old' trajectory
         YYtraj = readr(fhsimdata, Tendvec[1]+Psize);

   
         // extend sample by Pextend periods
         YYsim = dsgepred(parasim[j,.]',YYtraj,Pextend);
         wr = close(fhsimdata);
         
         // create new file
        oYYsim = opath $+ "/YYextend.dat";
        create fhYYsim2 = ^oYYsim with YYsim, nv_, 8;
        wr = writer(fhYYsim2, (YYtraj|YYsim) );
        wr = close(fhYYsim2);
     
         j = j+1;
         loopct = loopct + 1;

      endo;

   endif;

endo;

closeall fhpara;


