/* dsge_loaddata.g 
**
** specify datasetstr before calling procedure
**
** Year GDPC GDPDEF FPI PCEC RFF
**
** This file loads the data to be estimated.
*/



/* data transformations
** output growth = 100*ln(GDPC/GDPC(-1))
** inflation = 400*ln(GDPDEF/GDPDEF(-1))
** interest  = RFF
*/
if Tend < 163;
   
   load path = ^datapath YYall[] = ^datasetstr;
   YYall     = reshape(YYall, rows(YYall)/6,6);

   load path = ^datapath YYLABORall[] = ^labordatasetstr;
   YYLABORall = reshape(YYLABORall,  rows(YYLABORall)/5, 5);

   nobsall   = rows(YYall);
   tiall     = seqa(1964,0.25,nobsall);


   YYall[., 2] = YYall[., 2] ./ YYLABORall[., 5]; // adjust for per capita gdp growth
   YYalltr  = 100*ln(YYall[2:nobsall,2]./YYall[1:nobsall-1,2]) ~
         400*ln(YYall[2:nobsall,3]./YYall[1:nobsall-1,3]) ~  
         YYall[2:nobsall,6];
   tialltr  = tiall[2:nobsall];
else;       
   load path = ^datapath YYact[] = ^datasetstr;
   YYact     = reshape(YYact, rows(YYact)/8,8);

   load path = ^datapath YYfcst[] = ^labordatasetstr;
   YYfcst = reshape(YYfcst, rows(YYfcst)/9, 9);

   nobsall = rows(YYact) + rows(YYfcst);
   tialltr = seqa(1964.25, 0.25, nobsall);
    
   /* adjust forecast set */
   YYfcst[., 2 7 8] = YYfcst[., 2 7 8] - ones(1,3).*.YYfcst[.,9];

   YYalltr = YYact[.,2:8]|YYfcst[.,2:8];
   YYalltr[., 3] = YYalltr[., 3] - meanc(YYalltr[., 3]);
   YYalltr = YYalltr[., 1 6 7 3 2 4 5]; // reorder series

   YYalltr = YYalltr[., 1 6 7];
   YYalltr[., 2]=4*YYalltr[., 2];
endif;
   


YYR = YYalltr[1:Tend,.];
tiR = tialltr[1:Tend,.];
YYP = YYalltr[Tend+1:Tend+hmaxact,.];
tiP = tialltr[Tend+1:Tend+hmaxact,.];

