/* dsge_predeval.g
**
** Takes draws from predictive density and constructs rmse forecast errors
** for unconditional and conditional forecasts.
*/ 
library pgraph;
/*******************************************************************
* Read Forecast Densities
*******************************************************************/
corvar = 2~3;
corh = 4;

ind = corvar + (corh-1)*nv_;
ind;
lab = titlestr[corvar];

lpred       = lpath $+ "/predvar.dat";
open fhpred = ^lpred for read;

eofloop = 0;
loopct  = 1;
predsim_total = ones(1,nv_*hmaxact);

"Selected Correlations of the predictive density:";


do until eofloop; 

   /** Read blocks of size nblock **/
   predsim = readr(fhpred,nblock);
   predsim_total = predsim_total|predsim;
   loopct = loopct + 1;
	
   eofloop = eof(fhpred);
endo;

predsim_total = predsim_total[2:rows(predsim_total),ind];

begwind;
window(1, 1, 0);
xy(predsim_total[., 1], predsim_total[., 2])
endwind;
end;
