/* filename:    dsge_postrecursive11.g
*/

ldraw        = lpath $+ "\\pa"  ;
open fhldraw = ^ldraw for read;

paradraw       = readr(fhldraw,1);
impweightconst = dsge1steppreddens(paradraw',YY);

npara        = cols(paradraw);
drawrow      = seekr( fhldraw,nburn);

weightedmean  = zeros(1,npara);
weightedcross = zeros(npara,npara);
impweights    = zeros(1,1);

eofloop = 0;
do until eofloop; 

   /** Read blocks of size blocksize **/
   parasim = readr (fhldraw, blocksize);
   nread   = rows (parasim);
   npara   = cols (parasim);

   /** use every nuse-th draw **/
   indseq  = seqa (1, 1, nread);
   indseq  = indseq % nuse;
   indseq  = indseq .ne 0;

   parasim = delif (parasim, indseq);
   nread   = rows (parasim);

   eofloop = eof(fhldraw);   

   if ismiss (parasim) == 0;

      j = 1;

      do until j > nread;

         paraweight   = exp(dsge1steppreddens(parasim[j,.]',YY)
                            -impweightconst);        
         impweights   = impweights    + paraweight;
         weightedmean = weightedmean  + paraweight*parasim[j,.];
         weightedcross= weightedcross + paraweight*parasim[j,.]'*parasim[j,.];

       	 j = j+1;
      endo;

   endif;

endo;

closeall fhldraw;

parapostmean = (weightedmean/impweights)';
parapostcov  = weightedcross/impweights - parapostmean*parapostmean';

/** start log file **/
outstr = opath $+ "\\" $+ ftos(timedt,"%*.*lf",1,0) $+ "postrecursive11.log"; 
output file = ^outstr reset;

"Posterior Mean and StdD";
parapostmean~sqrt(diag(parapostcov));
output off;

