/********************************************************************
*  Model Specification and Global Setting
*
*  Last updated: 05/31/2005
********************************************************************/
dlibrary -a PsZtgSen,PsDtgSen;

msel = zeros(2,1);

/* Settings -- see below for descriptions */
datasel = 1;
msel[1] = 1;
msel[2] = 1;
subT    = 0;
mprior  = 1;
hmax    = 8;
nv_     = 3;
T0      = 4;
npitbin_ = 5;
chkpct_l = 0.05;
chkpct_h = 0.95;
nac_ = 4;
average_over_horizon = 1;

/************************************************
*  MSEL[1]:
*   1 without measurement error
*   2 with measurement errors
************************************************/
lmodel = "m" $+ ftos(msel[1],"%*.*lf",1,0);

/************************************************
*  MSEL[2]:
*   1 benchmark, output growth rule
*   2 demeaned model (not implemented)
*   3 benchmark, output gap rule
************************************************/
lmodel = lmodel $+ ftos(msel[2],"%*.*lf",1,0);

/************************************************
**  DATASEL
**
**  1 - Real Time Data - full sample
**
**  Note that choice of data effects the size
**  of the sample used in estimation.
************************************************/

dataselstr = "d" $+ ftos (datasel,"%*.*lf",1,0);

if datasel == 1;
   Tbegin = 78; /* Tbegin=1 corresponds to 1964Q2 */
               /* we have 32 forecast origin dates, starting 
               ** with March 97. Notice that the first forecast (nowcast)
               ** for March 97 is 1997Q1
               */
endif;

/*
** subT
** the number indicates that number offset
** from the initial observation in the data set.
*/
if subT > 0;
   subTstr  = "t" $+ ftos(subT,"%*.*lf",1,0);
else;
   subTstr  = "t0";
endif;

/************************************************
*  mprior
************************************************/
lprior = "p" $+ ftos(mprior,"%*.*lf",1,0);

/************************************************
*  titlestr: titles used for various graphs
************************************************/
titlestr = "GDP" $|
           "INF"  $|
           "FFR"   ;
