/* dsge_pred.g
**
** The program computes trajectories from the 
** the DSGE model.
*/
library pgraph;
vsel = {1 2 3};
/********************************************************************
* Initialize input files 
********************************************************************/
lpara       = lpath $+ "/pa.dat";
open fhpara = ^lpara for read;

parasim0 = readr(fhpara, 1);

eofloop = 0;

do until eofloop; 

   /** Read blocks of size nblock **/
   parasim = readr (fhpara, nblock);
   nread   = rows (parasim);
   npara   = cols (parasim);

   /** use every nuse-th draw **/
   indseq  = seqa (1, 1, nread);
   indseq  = indseq % nuse;
   indseq  = indseq .ne 0;

   parasim0 = parasim0 | delif (parasim, indseq);

   if ismiss (parasim) == 0;

      eofloop = eof (fhpara);   

   endif;

endo;
closeall fhpara;
p0 = meanc(parasim0);


{TT,QQ,RR,HH,DD,ZZ,VV,RC} = sysmat(p0, msel);

lab = "sigr" $|
      "sigg" $|
      "sigz";


irfh = 21;
tirf = seqa(0, 1, 21);
begwind;
_ptek = "figure.tkf";
_plctrl  = { 1, 1, 1 };
_pltype  = { 6, 1, 1 };
_pstype  = { 1, 2, 2};
_pcolor = 12;
_plwidth = 10;
fonts("microb");
_pscreen = 1;
_paxht = 0.4;
_pnumht = 0.3;

window(rows(lab), cols(vsel), 0);
setwind(1);

j = 1;
do until j > cols(QQ);
   yyirf = zeros(irfh, nv_);   
   i = 1;
   At = zeros(rows(TT), 1);
   QQpsd = zeros(cols(QQ), 1);
   QQpsd[j, 1] = sqrt(QQ[j, j]);
   do until i > irfh;
      At = TT*At + RR*QQpsd;
      QQpsd = zeros(cols(QQ), 1);
      yyirf[i, .] = (ZZ*At)';
      i = i +1;
   endo;

   i = 1;
   do until i > cols(vsel);
      xlabel(lab[j] $+ " -> " $+ titlestr[vsel[i]]);
      xy(tirf, yyirf[., vsel[i]]);

      nextwind;
      i = i + 1;
   endo;
   j = j + 1;
endo;

endwind;
ret = tkf2eps(_ptek,"irf.eps");
end;


