/* Simulate small sample distribution of chi2 statistic
*/
new;
closeall;
cls;

format /mat /on /mb1 /ros 16,8;
outwidth 256;

nsim   = 1E6;
nsamp  = 46;
h = 1;
chkpct = 0.9;
npitbin = 5;
PITbin  = seqa(1/npitbin,1/npitbin,npitbin);
thet = (-0.0);
s_mat = zeros(nsim,1);
PITfreq = zeros(npitbin, nsim);
j = 1;
do until j > nsim;

   pits = rndn(nsamp+h-1,1);
   pits[2:nsamp] = pits[2:nsamp] + thet*pits[1:nsamp-1];
   pits = cdfn(pits/sqrt(1+thet^2));
   PITfreq[., j] = counts(PITs,PITbin);
   s_mat[j] = sumc( (PITfreq[., j] - nsamp/npitbin)^2 )/(nsamp/npitbin);
   j = j+1;

endo;

s_mat = sortc(s_mat,1);
chkpct_ind = ceil(nsim*chkpct);
PITchi2 = s_mat[chkpct_ind,.];

"Critical Value";
PITchi2;
j = 1;
do until j > 5;
   PITfreq_c = PITfreq[j, .]';
   PITfreq_c = sortc(PITfreq_c, 1);
   h = PITfreq_c[ceil(0.95*nsim), .];
   print (j~h);
   j = j + 1;
endo;
end;
