specname =  lmodel $+lprior $+ dataselstr;

workpath = cdir(0);
      
datapath  = workpath  $+ "/data";
priopath  = workpath  $+ "/prior";
specpath  = workpath  $+ "/" $+ specname;
Rpostpath = specpath  $+ "/Rpost";
Rparapath = specpath  $+ "/Rpara";

chkdir = chk_dir(datapath);
chkdir = chk_dir(priopath);
chkdir = chk_dir(specpath);
chkdir = chk_dir(Rpostpath);
chkdir = chk_dir(Rparapath);

/*********************************************************
* Procedure: CHK_DIR
* checks if the 'path' directory exists, if not makes one.
* returns 0 when a directory is made, 1 when exists.
*********************************************************/
proc (1) = chk_dir(path);
local x, y, z, md;
x = cdir(0);
y = ChangeDir(path);
if y$=="";
   #ifos2win
	 md = "md " $+ path;
   #endif 
  
   #ifunix 
         md = "mkdir " $+ path;
   #endif
   dos ^md;
   z = 0;
else;
   y = ChangeDir(x);
   z = 1;
endif;

retp(z);
endp;


/*********************************************************
* Procedure: EXIST
* checks if the 'file' exists.
* returns 1 if exists, 0 if not
*********************************************************/
proc exist(filename);
retp(not (filesa(filename) $== ""));
endp;
